'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createQueue;

var _bull = require('bull');

var _bull2 = _interopRequireDefault(_bull);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createQueue(name) {
  var queue = (0, _bull2.default)(name);
  return {
    process: function process(fn) {
      var callbackWrapper = function callbackWrapper(job, done) {
        return fn(job.data, done);
      };
      var promiseWrapper = function promiseWrapper(job) {
        return fn(job.data);
      };

      queue.process(fn.length === 2 ? callbackWrapper : promiseWrapper);
    },
    add: function add(queueItem) {
      return queue.add(queueItem);
    }
  };
}